/****************************************************************************/
/* Ώۃ}CR R8C/M12A                                                    */
/* ̧ٓe     VAʐM                                                */
/* o[W   Ver.1.01                                                    */
/* Date         2012.11.25                                                  */
/* Copyright    lTX}CRJ[[                            */
/****************************************************************************/
/*
R8C/M12A}CR̃sAL̂悤Ɍ܂B
 1(P4_2)  2(P3_7)  3(PA_0)  4(P4_7) 6(P4_6) 9(P3_5) 10(P3_4) 11(P3_3) 12(P4_5)
ڑ    ڑ   ڑ   ڑ  ڑ  ڑ  ڑ   ڑ   ڑ

13(P1_7) 14(P1_6) 15(P1_5) 16(P1_4) 17(P1_3) 18(P1_2) 19(P1_1) 20(P1_0)
LED7     RXD0     LED5     TXD0     LED3     LED2     LED1     LED0

TeraTermȂǂ̒ʐM\tgɕóA܂͒ʐM\tg
͂܂B
*/

/*======================================*/
/* CN[h                         */
/*======================================*/
#include "sfr_r8m12a.h"                 /* R8C/M12A SFR̒`t@C   */

/*======================================*/
/* V{`                         */
/*======================================*/

/*======================================*/
/* vg^Cv錾                     */
/*======================================*/
void init( void );
int get_uart0( char *s );
int put_uart0( char r );
void put_uart0_str( char *str );
void put_uart0_num( long cnt, int keta );
void put_uart0_hex( unsigned long value, int keta );

/************************************************************************/
/* CvO                                                     */
/************************************************************************/
void main( void )
{
    char c;
    int ret;

    init();                             /*                        */

#if 1
    // 1
    while( 1 ) {
        ret = get_uart0( &c );
        if( ret == 1 ) put_uart0( c );
    }
#endif

#if 0
    // 2
    put_uart0_str( "R8C/M12A}CR 10i\łI\n" );
    put_uart0_num( 12345678, 8 );
    while( 1 );
#endif

#if 0
    // 3
    put_uart0_str( "R8C/M12A}CR 16i\łI\n" );
    put_uart0_hex( 0x1a2b3c4d, 8 );
    while( 1 );
#endif
}

/************************************************************************/
/* R8C/M12A XyVt@NVWX^(SFR)̏               */
/************************************************************************/
void init( void )
{
    /* |[g̓o͐ݒ */
    pd1 = 0x9f;                         /* |[g1̓o͐ݒ          */
    pd3 = 0xff;                         /* |[g3̓o͐ݒ          */
    pd4 = 0xff;                         /* |[g4̓o͐ݒ          */
    pda = 0xff;                         /* |[gA̓o͐ݒ          */

    /* UART0̐ݒ */
    mstuart = 0;                        /* UART0Lɂ            */

//  p14sel2 = 0;                        /* P1_4 = RXD0[qɂ        */
//  p14sel1 = 1;
//  p14sel0 = 0;

    p15sel2 = 0;                        /* P1_5 = RXD0[qɂ        */
    p15sel1 = 0;
    p15sel0 = 1;

//  p46sel2 = 0;                        /* P4_6 = RXD0[qɂ        */
//  p46sel1 = 0;
//  p46sel0 = 1;

    p14sel2 = 0;                        /* P1_4 = TXD0[qɂ        */
    p14sel1 = 0;
    p14sel0 = 1;

//  p42sel1 = 1;                        /* P4_2 = TXD0[qɂ        */
//  p42sel0 = 0;

//  p46sel2 = 0;                        /* P4_6 = TXD0[qɂ        */
//  p46sel1 = 1;
//  p46sel0 = 0;

    u0mr = 0x05;                        /* UART[h8bit               */
                                        /* 1įޯ,èȂ         */
    u0c0 = 0x10;                        /* U0BRGĿ:f1              */
    u0brg = 129;                        /* f1 / (bps*16) - 1            */
                                        /* = 20*10^6/(9600*16)-1=129.2  */
    te_u0c1 = 1;                        /* Mrbg:M      */
    re_u0c1 = 1;                        /* Mrbg:M      */
}

/************************************************************************/
/* PM                                                           */
/* @ Mi[AhX                                          */
/* ߂l -1:MG[ 0:MȂ 1:M *sɊi[            */
/************************************************************************/
int get_uart0( char *s )
{
    int ret = 0, data;
    char c;

    if (ri_u0c1 == 1){                  /* Mf[^H             */
        data = u0rb;
        *s = (char)data;
        ret = 1;
        if( data & 0xf000 ) {           /* G[H                 */
            /* G[͍Đݒ */
            re_u0c1 = 0;
            te_u0c1 = 0;
            c = u0mr;
            u0mr &= 0xf8;
            u0mr = c;
            re_u0c1 = 1;
            te_u0c1 = 1;
            ret = -1;
        }
    }
    return ret;
}

/************************************************************************/
/* Po                                                           */
/* @ Mf[^                                                    */
/* ߂l 0:M̂߁AMł 1:MZbg                   */
/************************************************************************/
int put_uart0( char r )
{
    if(ti_u0c1 == 1) {                  /* Mf[^ȂH             */
        u0tbl = r;
        return 1;
    } else {
        /* ɑM(̃f[^͑MɏI) */
        return 0;
    }
}

/************************************************************************/
/* o                                                           */
/* @ Mf[^                                                    */
/* ߂l                                                           */
/************************************************************************/
void put_uart0_str( char *str )
{
    while(*str != '\0') {
        /* '\n''\r\n'ɕϊ */
        if( *str == '\n' ) while( !put_uart0( '\r' ) );
        while( !put_uart0( *str ) );    /* 1M                    */
        str++;
    }
}

/************************************************************************/
/* 10io                                                           */
/* @ long l, int (1`8)                                         */
/* ߂l                                                           */
/************************************************************************/
void put_uart0_num( long value, int keta )
{
    int i = keta;
    long temp = 0;

    do {
        temp <<= 4;
        temp += value % 10;
        value /= 10;
    } while( --i );

    do {
        while( !put_uart0( (temp & 0xf) + '0' ) );  /* 1M        */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* 16io                                                           */
/* @ unsigned long l, int (1`8)                                */
/* ߂l                                                           */
/************************************************************************/
void put_uart0_hex( unsigned long value, int keta )
{
    char temp;

    do {
        temp = value >> (keta * 4 - 4);
        temp &= 0x0f;
        temp += (temp < 10) ? '0' : ('a'-10);

        while( !put_uart0( temp ) );  /* 1M                  */
    } while( --keta );
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/
